var match = {};  

match.substitute = function(subsD, termL) {
    result = [termL[0]];
    for (let str of termL.slice(1))
        result.push( Py.get(subsD, str, str) );
    return result;
}

match.matchSubset = function*( patternL, kbL, neg ) {
  //function str(s) {return JSON.stringify(s);}
  //console.log("match.matchSubset: patternL",str(patternL),"kbL",str(kbL),"oto",str(oto),"neg",str(neg));
  neg = neg || null;
  function dup(obj) {
    var copy = {};
    for (var key in obj)
      copy[key] = obj[key];
    return copy;
  }
  function matchAtomToGroundAtom(a, g, sD) {
    // Returns binding substitution on successful match, else null
    if (a[0] != g[0])  return null;
    if (a.length != g.length)  return null;
    var tD = dup(sD);
    for (var i=1;i<a.length;i++) {
      var value = tD[a[i]];
      if (!value)  value = a[i];
      if ( value == g[i] )  continue;
      if ( value[0] != '?' )  return null;
      tD[ value ] = g[i];
    }
    return tD;
  }
  function* atomMatches(atom, kbL, sD) {
    for (let kba of kbL) {
      var tD = matchAtomToGroundAtom(atom, kba, sD);
      if (tD)  yield [tD, [kba]];
    }
  }
  function* atomHasNoMatches(atom, kbL, sD) {
    var has_matches = false;
    for (let kba of kbL) {
      var tD = matchAtomToGroundAtom(atom, kba, sD);
      if (tD)  { has_matches=true; break; }
    }
    if (!has_matches)  yield [sD, []]
  }
  function* listMatches(atomL, negL, kbL, sD) {
    //function str(s) {return JSON.stringify(s);}
    //console.log("listMatches: atomL",str(atomL),"negL",str(negL),"kbL",str(kbL),"sD",str(sD));
    // Return bindings and ground atom matched
    var atom = atomL[0];
    atomL = atomL.slice(1);
    if (negL.length) {
      var neg = negL[0];
      negL = negL.slice(1);
    }
    else
      var neg = false;
    
    if (neg)
      var atom_matches = atomHasNoMatches(atom, kbL, sD);
    else
      var atom_matches = atomMatches(atom, kbL, sD);
    
    while(1) {
      var {value, done} = atom_matches.next();
      if (done)  break;
      var [tD, aL] = value;
      if (atomL.length==0)
        yield [tD, aL];
      else {
        var list_matches = listMatches(atomL, negL, kbL, tD);
        while(1) {
          var {value, done} = list_matches.next();
          if (done) break;
          var [uD, bL] = value;
          yield [uD, aL.concat(bL)];
        }
      }
    }
  }
  
  var matches = listMatches(patternL, neg, kbL);
  while (1) {
    var {value, done} = matches.next();
    if (done) break;
    yield value;
  }
}
  